#pragma once

#include <cstdint>



namespace Socket {
    /// Generic Socket Error Handling Functions
    // The following are general socket errors only. There may be other domain-specific error codes.

    // Semantically, these error codes are meant for the developer of UdpSocket_Old/TcpSocket_Old (Me)
    // TODO: translate error messages to be meaningful for the API consumer
    // TODO: Align Sockets folder and namespace

    void CheckErrors_recv(int errcode);
    void CheckErrors_socket(int errcode);
    void CheckErrors_accept(int errcode);
    void CheckErrors_shutdown(int errcode);
    void CheckErrors_close(int errcode);
    void CheckErrors_bind(int errcode);
    void CheckErrors_getsockname(int errcode);
    void CheckErrors_connect(int errcode);
    void CheckErrors_recvfrom(int errcode);
    void CheckErrors_send(int errcode);
    void CheckErrors_sendto(int errcode);
    void CheckErrors_setsockopt(int errcode);
    void CheckErrors_getaddrinfo(int errcode);

}